﻿using System;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Collections;
using System.Text;
using System.Windows.Forms;

namespace JMReferenceTraceParser
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                OpenFileDialog myOpenFileDialog = new OpenFileDialog();
                myOpenFileDialog.Filter = "Text Files|*.txt";
                if (myOpenFileDialog.ShowDialog() == DialogResult.OK)
                {
                    StreamReader sr = new StreamReader(myOpenFileDialog.FileName);
                    TraceFileLabel.Text = myOpenFileDialog.FileName;
                    string CurrentLine = "";
                    while (sr.Peek() != -1)
                    {
                        CurrentLine = sr.ReadLine();
                        if (CurrentLine.StartsWith("Frame"))
                        {
                            // No we start reading the lines
                            // 1- Skip This line and the dashed line
                            CurrentLine = sr.ReadLine(); // --------
                            DataTable FramesTable = new DataTable("FramesTable");
                            FramesTable.Columns.Add("FrameNumber", typeof(Int32));
                            FramesTable.Columns.Add("FrameType", typeof(string));
                            FramesTable.Columns.Add("FrameSize", typeof(Int64));
                            DataRow row;
                            string[] CurrentLinePhrases;
                            string[] Phrase0Splits;
                            // 2- Keep reading lines, split the lines to phrases
                            while (true)
                            {
                                CurrentLine = sr.ReadLine(); // 00000(IDR) ... etc
                                CurrentLinePhrases = CurrentLine.Split(new char[] { ')' });
                                if (CurrentLinePhrases.Length <= 1)
                                    break;
                                
                                CurrentLinePhrases[0] = CurrentLinePhrases[0].Replace(" ", "").Trim();
                                string[] FirstPartStrings = CurrentLinePhrases[0].Split(new char[] { '(' });
                                string[] NumberPartStrings = CurrentLinePhrases[1].Trim().Split(new char[] { ' ' });
                                try
                                {

                                    row = FramesTable.NewRow();

                                    if (CurrentLine.Contains("IDR"))
                                    {
                                        row["FrameNumber"] = Int32.Parse(FirstPartStrings[0].ToString());
                                        row["FrameType"] = "IDR";
                                        row["FrameSize"] = Int64.Parse(NumberPartStrings[0].ToString());
                                    }
                                    else if (CurrentLine.Contains("P"))
                                    {
                                        row["FrameNumber"] = Int32.Parse(FirstPartStrings[0].ToString());
                                        row["FrameType"] = "P";
                                        row["FrameSize"] = Int64.Parse(NumberPartStrings[0].ToString());
                                        if (Int64.Parse(NumberPartStrings[0].ToString().Trim()) == 0)
                                        {
                                            NumberPartStrings[0] = NumberPartStrings[0];
                                        }
                                    }
                                    else if (CurrentLine.Contains("B"))
                                    {
                                        row["FrameNumber"] = Int32.Parse(FirstPartStrings[0].ToString());
                                        row["FrameType"] = "B";
                                        row["FrameSize"] = Int64.Parse(NumberPartStrings[0].ToString());
                                    }

                                    FramesTable.Rows.Add(row);
                                }
                                catch (Exception ex)
                                {
                                    MessageBox.Show(ex.Message);
                                    break;
                                }
                            }
                            FramesTable.DefaultView.Sort = "FrameNumber ASC";
                            FramesDataGridView.DataSource = FramesTable.DefaultView.ToTable();

                        }
                    }


                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message +"\n"+ ex.StackTrace +"\n");
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (FramesDataGridView.DataSource != null)
            {
                SaveFileDialog mySaveFileDialog = new SaveFileDialog();
                mySaveFileDialog.Filter = "Text Files|*.txt";
                if (mySaveFileDialog.ShowDialog() == DialogResult.OK)
                {
                    StreamWriter myStreamWriter = new StreamWriter(mySaveFileDialog.FileName);

                    DataTable FramesTable = (DataTable)FramesDataGridView.DataSource;
                    foreach (DataRow row in FramesTable.Rows)
                    {
                        if (FrameNumberCheckBox.Checked)
                            myStreamWriter.Write(row["FrameNumber"].ToString() + "\t");
                        if (FrameTypecheckBox.Checked)
                            myStreamWriter.Write(row["FrameType"].ToString() + "\t");
                        if (FrameSizeCheckBox.Checked)
                            myStreamWriter.Write(row["FrameSize"].ToString());
                        myStreamWriter.WriteLine("");
                    }

                    myStreamWriter.Close();
                }
            }
            else
            {
                MessageBox.Show(" Load Trace File First To Parse");
            }
        }
    }
}
